/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2022 Tianjin KYLIN Information Technology Co., Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 */
#ifndef ADDNETBTN_H
#define ADDNETBTN_H

#include <QObject>
#include <QWidget>
#include <QPushButton>
#include <QTranslator>
#include <QApplication>
#include <QLabel>

class AddNetBtn : public QPushButton
{
    Q_OBJECT
public:
    AddNetBtn(bool isWlan, QWidget *parent = nullptr);
    ~AddNetBtn();

    void setTextLabel(const QString str) {
        m_textLabel->setText(str);
    }

protected:
    virtual void leaveEvent(QEvent * event);
    virtual void enterEvent(QEvent * event);
    void paintEvent(QPaintEvent *event);

private:
    QLabel *m_textLabel;

Q_SIGNALS:
    void enterWidget();
    void leaveWidget();
};

#endif // ADDNETBTN_H
